<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <link href="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.css" rel="stylesheet">
        <script src="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.js"></script>
        <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
        <script type="text/javascript" src="./rainbow-js/lib/RainbowTools.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/RainbowRequest.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/RainbowDom.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/jsLib.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/IFML.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/template.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/RainbowTemplate.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/IFMLComponent/GenericComponent.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/IFMLComponent/ViewContainerComponent.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/IFMLComponent/ViewComponent.js"></script>
        <script type="text/javascript" src="./rainbow-js/lib/IFMLComponent/EventComponent.js"></script>
    </head>
    <body vm.bind="vm">
    </body>
    <script type="text/javascript">
        var api = [
            {url: "data:text/plain;charset:utf8,{\"songs\": [{\"title\": \"Croissant\", \"author\":437},{\"title\": \"choco\", \"author\":438}]}", method: "GET", key: "songs", property: "songs", reuseCache: 0},
        ];

        class VmTest {
            constructor() {
                this.start = new Date().getTime();
                this.songs = [];
                this.song = {};
                this.proxy = null;
                this.callbacks = {songs: (data)=>{this.updateSongs(data);}};
                this.eventsToRegister = [];
            }

            updateSongs(data) {
                this.songs = data;
                this.proxy.songs = this.songs;
                console.log(new Date().getTime()-this.start, "ms for updateSong since page startup");
            };

            changesong(song) {
                this.song = song;
                this.proxy.song = this.song;
            }
        }
        var model = {"elements":[
                        {"attributes":{"name":"Application","default":true,"landmark":false,"xor":false},"id":"application","type":"ifml.ViewContainer"},
                        {"attributes":{"name":"Change Song","parameters":["song"],"results":[]},"id":"changesong","type":"ifml.Action"},
                        {"attributes":{"name":"Start Song","parameters":["song"],"results":[]},"id":"startsong","type":"ifml.Action"},
                        {"attributes":{"name":"Stop Song","parameters":["song"],"results":[]},"id":"stopsong","type":"ifml.Action"},
                        {"attributes":{"name":"Player","default":false,"landmark":false,"xor":true},"id":"player","type":"ifml.ViewContainer"},
                        {"attributes":{"name":"SongList","stereotype":"list","fields":["author","title"],"collection":"songs","filters":[]},"id":"songlist","type":"ifml.ViewComponent"},
                        {"attributes":{"name":"started"},"id":"song-started-from-list","type":"ifml.Event"},
                        {"attributes":{"name":"started"},"id":"songstarted","type":"ifml.Event"},{"attributes":{"name":"stopped"},"id":"songstopped","type":"ifml.Event"},
                        {"attributes":{"name":"Stopped","default":false,"landmark":false,"xor":false},"id":"stopped","type":"ifml.ViewContainer"},
                        {"attributes":{"name":"Playing","default":false,"landmark":false,"xor":false},"id":"playing","type":"ifml.ViewContainer"},
                        {"attributes":{"name":"selected","stereotype":"selection"},"id":"songselected","type":"ifml.Event"},
                        {"attributes":{"name":"PlayerStopped","stereotype":"details","fields":["title"],"collection":"song"},"id":"playerstopped","type":"ifml.ViewComponent"},
                        {"attributes":{"name":"PlayerPlaying","stereotype":"details","fields":["title"],"collection":"song"},"id":"playerplaying","type":"ifml.ViewComponent"},
                        {"attributes":{"name":"play"},"id":"play","type":"ifml.Event"},
                        {"attributes":{"name":"stop"},"id":"stop","type":"ifml.Event"},
                        {"attributes":{"bindings":[{"input":"song","output":"id"}]},"id":"3cd3db4e-6e43-49fa-a55f-09a7a6cc11d9","type":"ifml.NavigationFlow"},
                        {"attributes":{"bindings":[{"input":"id","output":"id"}]},"id":"3d47f29c-964c-4bd8-bf3f-7a8aa00fe5ef","type":"ifml.DataFlow"},
                        {"attributes":{"bindings":[{"input":"song","output":"id"}]},"id":"505e21ac-2693-4da1-be00-fb94c117ba66","type":"ifml.NavigationFlow"},
                        {"attributes":{"bindings":[{"input":"songs","output":"id"}]},"id":"7860e2d7-3b3b-4173-a9c5-4b2fe2c83d73","type":"ifml.NavigationFlow"},
                        {"attributes":{"bindings":[]},"id":"abd7a45b-a3a7-40e0-bfa8-1dec1d58b97f","type":"ifml.NavigationFlow"},
                        {"attributes":{"bindings":[]},"id":"b1e4fa39-931e-4b0a-ab07-cc6dfa140888","type":"ifml.NavigationFlow"},
                        {"attributes":{"bindings":[{"input":"id","output":"id"}]},"id":"effbac2d-f6d5-4a8f-9536-29835da3ad9d","type":"ifml.DataFlow"},
                        {"attributes":{"bindings":[]},"id":"fafe15b1-d7d4-47ef-bbfe-a5d137e6f173","type":"ifml.NavigationFlow"}
                        ],
                    "relations":[
                        {"type":"hierarchy","parent":"application","child":"player"},
                        {"type":"hierarchy","parent":"application","child":"songlist"},
                        {"type":"hierarchy","parent":"changesong","child":"song-started-from-list"},
                        {"type":"hierarchy","parent":"startsong","child":"songstarted"},
                        {"type":"hierarchy","parent":"stopsong","child":"songstopped"},
                        {"type":"hierarchy","parent":"player","child":"stopped"},
                        {"type":"hierarchy","parent":"player","child":"playing"},
                        {"type":"hierarchy","parent":"songlist","child":"songselected"},
                        {"type":"hierarchy","parent":"stopped","child":"playerstopped"},
                        {"type":"hierarchy","parent":"playing","child":"playerplaying"},
                        {"type":"hierarchy","parent":"playerstopped","child":"play"},
                        {"type":"hierarchy","parent":"playerplaying","child":"stop"},
                        {"type":"source","flow":"3cd3db4e-6e43-49fa-a55f-09a7a6cc11d9","source":"stop"},
                        {"type":"source","flow":"3d47f29c-964c-4bd8-bf3f-7a8aa00fe5ef","source":"songlist"},
                        {"type":"source","flow":"505e21ac-2693-4da1-be00-fb94c117ba66","source":"play"},
                        {"type":"source","flow":"7860e2d7-3b3b-4173-a9c5-4b2fe2c83d73","source":"songselected"},
                        {"type":"source","flow":"abd7a45b-a3a7-40e0-bfa8-1dec1d58b97f","source":"songstopped"},
                        {"type":"source","flow":"b1e4fa39-931e-4b0a-ab07-cc6dfa140888","source":"song-started-from-list"},
                        {"type":"source","flow":"effbac2d-f6d5-4a8f-9536-29835da3ad9d","source":"songlist"},
                        {"type":"source","flow":"fafe15b1-d7d4-47ef-bbfe-a5d137e6f173","source":"songstarted"},
                        {"type":"target","flow":"3cd3db4e-6e43-49fa-a55f-09a7a6cc11d9","target":"stopsong"},
                        {"type":"target","flow":"3d47f29c-964c-4bd8-bf3f-7a8aa00fe5ef","target":"playerstopped"},
                        {"type":"target","flow":"505e21ac-2693-4da1-be00-fb94c117ba66","target":"startsong"},
                        {"type":"target","flow":"7860e2d7-3b3b-4173-a9c5-4b2fe2c83d73","target":"changesong"},
                        {"type":"target","flow":"abd7a45b-a3a7-40e0-bfa8-1dec1d58b97f","target":"playerstopped"},
                        {"type":"target","flow":"b1e4fa39-931e-4b0a-ab07-cc6dfa140888","target":"playerplaying"},
                        {"type":"target","flow":"effbac2d-f6d5-4a8f-9536-29835da3ad9d","target":"playerplaying"},
                        {"type":"target","flow":"fafe15b1-d7d4-47ef-bbfe-a5d137e6f173","target":"playerplaying"}
                    ]};
        new IFML(model, VmTest, api);
    </script>
</html>
